# class Giano(Api):
#     def __init__(self, config, debug=False, seed=205, backend="giano"):
#         super().__init__(config, debug, seed, backend)
#         # self.token_request = self._set_token_request()

#     def _get_token_request(self) -> dict:
#         return {
#             "username": self.config["kc_client_id"],
#             "password": self.config["kc_client_secret"],
#             "realm": self.config["realm"],
#             "audience": "ced",
#         }

#     async def get_token(self) -> bool:
#         try:
#             session = aiohttp.ClientSession()
#             async with aiohttp.ClientSession(
#                 timeout=self.timeout, trace_configs=[self.trace_config]
#             ) as session:
#                 resp = await session.post(
#                     self.config["kc_url"], json=self._get_token_request()
#                 )

#                 if resp.status == 200:
#                     payload = await resp.json()
#                     if self.debug:
#                         log.debug("response payload: %s", payload)
#                     self.login = True
#                     log.info(f"login to {self.backend} ok, token ready")
#                     try:
#                         self.config["token"] = payload["token"]
#                         self.config["expire"] = time.time()
#                         log.info("token: %s", payload["token"])
#                     except Exception as e:
#                         log.error(str(e))
#                         self.login = False
#                         return self.login
#                 elif resp.status == 400:
#                     log.warning("invalide response: %s" % await resp.json())
#                     self.login = False
#                 return self.login

#         except (aiohttp.ClientError, asyncio.TimeoutError):
#             log.warning(f"connection error to {self.backend}")
#             self.login = False
#             return self.login

#     async def refreshToken(self) -> bool:
#         request = {
#             "grant_type": "refresh_token",
#             "client_id": self.config["kc_client_id"],
#             "client_secret": self.config["client_secret"],
#             "refresh_token": self.config["refresh_token"],
#         }
#         async with aiohttp.ClientSession(trace_configs=[self.trace_config]) as session:
#             resp = await session.post(self.config["refreshToken"], json=request)
#             if resp.status == 200:
#                 payload = await resp.json()
#                 if payload and "errorCode" in payload:
#                     log.warning("TODO deve andare in resp.status=400")
#                     return False
#                 try:
#                     self.config["token"] = payload["token"]
#                     self.config["refresh_token"] = payload["refreshToken"]
#                     self.config["token_date"] = time.time()
#                     log.debug("refreshToken response: %s" % payload)
#                 except Exception as e:
#                     # raise
#                     log.error(str(e))
#                     return False
#                 return True
#             if resp.status == 400:
#                 log.warning("invalide response: %s" % await resp.json())
#                 return False
#             log.warning("refreshToken response: %s" % resp)
#             return False

#     async def base_query(self, plate="EN675TL", simulate_expired=False):
#         if "v3" in self.config["calls"]["cerbero_be_url"]:
#             return await self._query_saferplace(plate, simulate_expired)
#         else:
#             return await self._query_giano(plate)

#     async def _query_saferplace(
#         self, plate="EN675TL", simulate_expired=False
#     ) -> ResponseQueryBasic:
#         """Call to SaferPlace backend"""
#         params = {
#             "license": plate,
#             "client": "test",
#         }

#         async with aiohttp.ClientSession(
#             trace_configs=[self.trace_config], timeout=self.timeout
#         ) as session:
#             headers = (
#                 {"Authorization": f"{self.config['token']}"}
#                 if not simulate_expired
#                 else {}
#             )
#             log.info(f"{self.backend} query params: {params}")
#             try:
#                 chosen_url = self._select_url()
#                 resp = await session.get(chosen_url, params=params, headers=headers)
#             except asyncio.TimeoutError:
#                 return {"error": "timeout"}
#             except Exception as e:
#                 log.error(e)
#                 return {"error": "generic"}
#             if resp.status in (204, 200):  # esito positivo
#                 payload = await resp.json()
#                 log.info(f"{self.backend} response: {payload}")
#                 if payload and "vehicle" in payload:
#                     return payload["vehicle"]
#                 else:
#                     log.error("response without payload")
#                     return {"error": "nodata"}

#             if resp.status == 401:
#                 log.warning(
#                     "access denyed: %s, try to refresh token", await resp.json()
#                 )
#                 self.resetToken()
#             log.warning("query failed with http code %s", resp.status)
#             return {"error": resp.status}

#     async def _query_giano(
#         self, plate="EN675TL", simulate_expired=False
#     ) -> ResponseQueryBasic:
#         """Call to Giano backend"""
#         params = {"targa": plate}

#         async with aiohttp.ClientSession(
#             trace_configs=[self.trace_config],
#             timeout=self.timeout,
#         ) as session:
#             headers = (
#                 {"Authorization": f"Bearer {self.config['token']}"}
#                 if not simulate_expired
#                 else {}
#             )
#             log.info(f"{self.backend} query params: {params}")
#             try:
#                 chosen_url = self._select_url()
#                 resp = await session.get(chosen_url, params=params, headers=headers)
#             except asyncio.TimeoutError:
#                 return {"error": "timeout"}
#             except Exception as e:
#                 log.error(e)
#                 return {"error": "generic"}
#             if resp.status in (204, 200):  # esito positivo
#                 payload = await resp.json()
#                 log.info(f"{self.backend} response: {payload}")
#                 if payload and len(payload) > 0:
#                     payload = payload[0]
#                     if "dati" in payload:
#                         insurance = payload["dati"]["assicurato"]
#                         checking = payload["dati"]["revisionato"]
#                         blacklist = payload.get("blacklist", 0)
#                         if payload.get("prestanome"):
#                             blacklist = 1
#                         result = ResponseQueryBasic(
#                             plate=plate,
#                             insurance=insurance,
#                             checking=checking,
#                             blacklist=blacklist,
#                         )
#                         return result.model_dump()
#                 else:
#                     log.error("response without payload")
#                     return {"error": "nodata"}

#             if resp.status == 401:
#                 log.warning(
#                     "access denyed: %s, try to refresh token", await resp.json()
#                 )
#                 self.resetToken()
#             log.warning("query failed with http code %s", resp.status)
#             return {"error": resp.status}


# class FakeGiano(Giano):
#     def __init__(
#         self, config, debug=False, seed=205, forced_url=None, backend="fake-giano"
#     ):
#         super().__init__(config, debug, seed, backend)
#         self.forced_url = forced_url

#     def _select_url(self) -> str:
#         return _select_mock_url(self)


# import asyncio
# import logging
# import time

# # for testing

# import aiohttp
# import configargparse
# import yaml

# log = logging.getLogger(__name__)

# parser = configargparse.get_argument_parser()
# # parser.add_argument("--http-port", type=int, default=8024)
# parser.add_argument("--timeout", type=int, default=10, help="query timeout")
# # parser.add_argument("--secret", default="tgbrfvedcwsx")


# async def on_request_start(session, trace_config_ctx, params):
#     log.warning("request: url='%s' headers=%s", params.url, dict(params.headers))


# async def on_request_end(session, trace_config_ctx, params):
#     log.warning("response: %s", await params.response.text())


# class Api:
#     def __init__(self, config, debug=False):
#         with open(config) as f:
#             self.config = yaml.safe_load(f)["api"]

#         self.trace_config = aiohttp.TraceConfig()
#         self.debug = debug
#         if debug:  # logging.DEBUG >= logging.root.level:
#             log.warning("enable debug")
#             self.trace_config.on_request_start.append(on_request_start)
#             self.trace_config.on_request_end.append(on_request_end)

#         self.login: bool = (
#             self.hasToken()
#         )  # nel caso il token sia statico nella configurazione
#         log.info("token preloaded: %s", self.login)

#     # self.initRestServer()

#     # def initRestServer(self):

#     #     app = Sanic(__name__)
#     #     app.add_route(self.getPlateServer, '/plate/<key>')
#     #     loop = asyncio.get_event_loop()
#     #     self.srv = loop.run_until_complete(srv_coro)
#     #     loop.run_until_complete(self.srv.start_serving())
#     #     loop.create_task(self.srv.serve_forever())

#     def __repr__(self):
#         return str(self.config)

#     def hasToken(self):
#         return self.config.get("token", "") != ""

#     async def get_token(self, client_id="", client_secret="", realm="") -> bool:
#         """
#         response = {
#             'token': 'c778cd06f09bd381a5b57941c58f1251099b01d6',
#             'refreshToken': '200a76c37c6432e2a4dc75958a0b265ddbda13c6'
#             }

#         """

#         request = {
#             "username": client_id or self.config["client_id"],
#             "password": client_secret or self.config["client_secret"],
#             "realm": realm or self.config["realm"],
#             "audience": "ced",
#         }
#         try:
#             async with aiohttp.ClientSession(
#                 trace_configs=[self.trace_config]
#             ) as session:
#                 resp = await session.post(self.config["login"], json=request)

#                 if resp.status == 200:
#                     payload = await resp.json()
#                     if self.debug:
#                         log.debug("response payload: %s", payload)
#                     self.login = True
#                     log.info("login ok, token ready")
#                     try:
#                         self.config["token"] = payload["token"]
#                         self.config["expire"] = time.time()
#                         log.info("token: %s", payload["token"])
#                     except Exception as e:
#                         log.error(str(e))
#                         self.login = False
#                     return self.login
#                 elif resp.status == 400:
#                     log.warning("invalide response: %s" % await resp.json())
#                     self.login = False
#                 return self.login
#         except (aiohttp.ClientError, asyncio.TimeoutError):
#             log.warning("connection error")
#             self.login = False
#             return self.login

#     # async def recognizedPlatesClient(self, mev_unit, plates=[], simulate_expired=False, refreshed=1) -> bool:
#     #     """
#     #     plate = {'plate':'xxx', latitude: 45.444, longitude: 11.444}
#     #     """

#     #     if refreshed > 3:  # limitiamo la chiamata ricorsiva
#     #         log.warn(f"maximun refresh token reached {refreshed}")
#     #         return False

#     #     plates_cleaned = []
#     #     for plate in plates:
#     #         plate_cleaned = {
#     #             'plate': plate['plate_ascii'],
#     #             'latitude': plate['latitude'],
#     #             'longitude': plate['longitude'],
#     #             'readingDateTime': datetime.fromtimestamp(plate['timestamp']).isoformat(),
#     #             "externalId": plate['key'],
#     #             }
#     #         plates_cleaned.append(plate_cleaned)
#     #         #print(plate_cleaned)
#     #         if 'filename' in plate_cleaned:
#     #             plate_cleaned.pop('filename')

#     #     request = {
#     #         'cameraCode': mev_unit,
#     #         'data': plates_cleaned,
#     #         #'readingDateTime': datetime.now().isoformat()
#     #     }

#     #     # if not upload:
#     #     #     print(f"simulate connection to {self.config['recognizedPlates']} headers={{'Authorization': 'Bearer {self.config['token']}'}}")
#     #     #     print(f"payload: {request}")
#     #     #     return True

#     #     async with aiohttp.ClientSession(trace_configs=[self.trace_config]) as session:
#     #         headers = {"Authorization": f"Bearer {self.config['token']}"} if not simulate_expired else {}
#     #         log.debug("recognizedPlates payload: %s" % request)
#     #         resp = await session.post(self.config['recognizedPlates'], json=request, headers=headers)
#     #         if resp.status in (204, 200):  # esito positivo
#     #             payload = await resp.json()
#     #             if 'items' in payload:

#     #                 return payload['items'] == len(plates)
#     #             return True
#     #         if resp.status == 401:
#     #             log.warning("access denyed: %s, try to refresh token" % await resp.json())
#     #             self.resetToken()
#     #             if await self.refreshToken():
#     #                 return await self.recognizedPlates(plates, refreshed=refreshed+1)
#     #         log.warn('upload failed with http code %s', resp.status)
#     #         return False

#     async def base_query(self, plate="EN675TL", simulate_expired=False):
#         if "v3" in self.config["calls"]["base"]:
#             return await self._query_saferplace(plate, simulate_expired)
#         else:
#             return await self._query_giano(plate)

#     async def _query_giano(self, plate="EN675TL", simulate_expired=False):
#         params = {
#             "targa": plate,
#             # "tipo": "AUTOVEICOLO",
#         }
#         async with aiohttp.ClientSession(
#             trace_configs=[self.trace_config],
#             timeout=aiohttp.ClientTimeout(total=self.config.get("timeout", 10)),
#         ) as session:
#             headers = (
#                 {"Authorization": f"Bearer {self.config['token']}"}
#                 if not simulate_expired
#                 else {}
#             )
#             log.info("_giano query params: %s", params)
#             try:
#                 resp = await session.get(
#                     self.config["calls"]["base"], params=params, headers=headers
#                 )
#                 # return {"error": "timeout"}
#                 # await asyncio.sleep(3)
#             except asyncio.TimeoutError():
#                 return {"error": "timeout"}
#             except Exception as e:
#                 log.error(e)
#                 return {"error": "generic"}
#             if resp.status in (204, 200):  # esito positivo
#                 payload = await resp.json()
#                 log.info("response: %s", payload)
#                 if payload and len(payload) > 0:
#                     payload = payload[0]
#                     if "dati" in payload:
#                         insurance = payload["dati"]["assicurato"]
#                         checking = payload["dati"]["revisionato"]
#                         blacklist = payload.get("blacklist", 0)
#                         if payload.get("prestanome"):
#                             blacklist = 1
#                         return {
#                             "plate": plate,
#                             "insurance": insurance,
#                             "checking": checking,
#                             "blacklist": blacklist,
#                         }
#             if resp.status == 401:
#                 log.warning(
#                     "access denyed: %s, try to refresh token", await resp.json()
#                 )
#                 self.resetToken()
#                 # if await self.refreshToken():
#                 #     return await self.recognizedPlates(plates, refreshed=refreshed+1)
#             log.warning(
#                 "query failed with http-code=%s response=%s",
#                 resp.status,
#                 await resp.text(),
#             )
#             return {"error": resp.status}

#     async def _query_saferplace(self, plate="EN675TL", simulate_expired=False):
#         """visura base"""
#         params = {
#             "license": plate,
#             "client": "test",
#         }

#         # if not upload:
#         #     print(f"simulate connection to {self.config['recognizedPlates']} headers={{'Authorization': 'Bearer {self.config['token']}'}}")
#         #     print(f"payload: {request}")
#         #     return True

#         async with aiohttp.ClientSession(
#             trace_configs=[self.trace_config],
#             timeout=aiohttp.ClientTimeout(total=self.config.get("timeout", 10)),
#         ) as session:
#             headers = (
#                 {"Authorization": f"{self.config['token']}"}
#                 if not simulate_expired
#                 else {}
#             )
#             log.debug("base_query params: %s", params)
#             try:
#                 resp = await session.get(
#                     self.config["calls"]["base"], params=params, headers=headers
#                 )
#             except asyncio.TimeoutError():
#                 return {"error": "timeout"}
#             if resp.status in (204, 200):  # esito positivo
#                 payload = await resp.json()
#                 log.debug("base_query result: %s", payload)
#                 if payload and "vehicle" in payload:
#                     return payload["vehicle"]
#             if resp.status == 401:
#                 log.warning(
#                     "access denyed: %s, try to refresh token", await resp.json()
#                 )
#                 self.resetToken()
#                 # if await self.refreshToken():
#                 #     return await self.recognizedPlates(plates, refreshed=refreshed+1)
#             log.warning("query failed with http code %s", resp.status)
#             return {"error": resp.status}

#     def resetToken(self):
#         self.config["token"] = ""
#         self.login = False

#     async def refreshToken(self) -> bool:
#         """
#         response = {
#             'token': 'c778cd06f09bd381a5b57941c58f1251099b01d6',
#             'refreshToken': '200a76c37c6432e2a4dc75958a0b265ddbda13c6'
#             }

#         response = {'errorCode': 0, errorDescription: 'bla bla'}
#         """

#         request = {
#             "grant_type": "refresh_token",
#             "client_id": self.config["client_id"],
#             "client_secret": self.config["client_secret"],
#             "refresh_token": self.config["refresh_token"],
#         }
#         async with aiohttp.ClientSession(trace_configs=[self.trace_config]) as session:
#             resp = await session.post(self.config["refreshToken"], json=request)
#             if resp.status == 200:
#                 payload = await resp.json()
#                 if payload and "errorCode" in payload:
#                     log.warning("TODO deve andare in resp.status=400")
#                     return False
#                 try:
#                     self.config["token"] = payload["token"]
#                     self.config["refresh_token"] = payload["refreshToken"]
#                     self.config["token_date"] = time.time()
#                     log.debug("refreshToken response: %s" % payload)
#                 except Exception as e:
#                     # raise
#                     log.error(str(e))
#                     return False
#                 return True
#             if resp.status == 400:
#                 log.warning("invalide response: %s" % await resp.json())
#                 return False
#             log.warning("refreshToken response: %s" % resp)
#             return False
