import os


def getStats():
    """
    thermal zone name is /sys/devices/virtual/thermal/thermal_zone0/type

    """
    stats = {"temps": {"CPU": 40.0}}

    if os.path.exists("/sys/devices/virtual/thermal/thermal_zone0/temp"):
        with open("/sys/devices/virtual/thermal/thermal_zone0/temp") as f:
            stats["temps"]["CPU"] = float(f.read()) / 1000

    return stats


if __name__ == "__main__":
    print(getStats())
