# pytest_plugins = "pytest_asyncio"
import pytest


def pytest_addoption(parser):
    parser.addoption(
        "--api",
        action="store",
        default="/app/mev-brain/giano-api.yml",
        help="configuration file",
    )


@pytest.fixture(scope="session", autouse=True)
def api(request):
    return request.config.getoption("--api")
